/******************************************************************
 * clg.h
 * 
 * CLG driver
 * 
 * Copyright(C) SEIKO EPSON CORPORATION 2009. All rights Reserved.
 *****************************************************************/

#ifndef CLG_H_
#define CLG_H_


#include <s1c176xx.h>


#ifdef	BIT_FIELD
/***********************************************
 ****** The Definition of bit field         ****
 ***********************************************/
struct clg_pclkBitF {
	unsigned int	pcken	: 2;
	unsigned int			: 6;
};

struct clg_cclkBitF {
	unsigned int	cclkgr	: 2;
	unsigned int			: 6;
};
#endif	// end of BIT_FIELD


/***********************************************
 ****** The Definition of base address      ****
 ***********************************************/
#define	CLG_BASE_ADDR						(BASE_ADDR+CLG_OFFSET)


/***********************************************
 ****** The Definition of Clock Generator ******
 ****** [CLG]                             ******
 ***********************************************/
// PCLK Control Register
#define	R08_CLG_PCLK						(volatile unsigned char *)(unsigned long)(CLG_BASE_ADDR+0x00)
	#define	PCKEN_SFT							0
	#define	PCKEN								BIT(0x0003, PCKEN_SFT)		// PCLK Enable
		#define	PCKEN_DISABLE						0x00						// disable
		#define	PCKEN_ENABLE						0x03						// enable

#ifdef	BIT_FIELD
#define CLG_PCLK							*(volatile unsigned char *)(BASE_ADDR+0x1080)
#define BF_CLG_PCLK							(*(volatile struct clg_pclkBitF *)(BASE_ADDR+0x1080))
	#define CLG_PCLK_PCKEN						BF_CLG_PCLK.pcken			// PCLK enable
#endif	// end of BIT_FIELD


// CCLK Control Register
#define	R08_CLG_CCLK						(volatile unsigned char *)(unsigned long)(CLG_BASE_ADDR+0x01)
	#define	CCLKGR_SFT							0
	#define	CCLKGR								BIT(0x0003, CCLKGR_SFT)		// CCLK Clock Gear Ratio Select

#ifdef	BIT_FIELD
#define CLG_CCLK							*(volatile unsigned char *)(BASE_ADDR+0x1081)
#define BF_CLG_CCLK							(*(volatile struct clg_cclkBitF *)(BASE_ADDR+0x1081))
	#define CLG_CCLK_CCLKGR						BF_CLG_CCLK.cclkgr			// CCLK clock gear ratio select
#endif	// end of BIT_FIELD


#endif	// end of CLG_H_
