/**
 * @file	vd1.c
 * @brief	heavy load protection driver
 *
 * - Copyright(C) SEIKO EPSON CORPORATION 2009. All rights Reserved.
 */

#include <s1c176xx.h>

#ifdef	PE_VD1
#include <vd1_api.h>

/*
 * definition of "define"
 */


/*
 * definition of constants
 */


/*
 * Declarations of function prototype
 */
void VD1_setMode(unsigned char mode);


/**
 * @brief	set heavy load protection mode.
 * - 1. check parameter.
 * - 2. set a heavy load protection mode on / off.
 *
 * @param	mode; unsigned char: 	select heavy load protection mode on / off.
 * - 		VD1_ON  : heavy load protection mode Enable.
 * - 		VD1_OFF : heavy load protection mode Disable.
 *
 * @return	none
 * @date	2010/03/03
 */
void VD1_setMode(unsigned char mode)
{
	if(mode == VD1_ON) {
		// heavy load protection mode Enable.
		RegSet(R08_VD1_CTL, HVLD);
	}
	else
	{
		// heavy load protection mode Disable.
		RegClear(R08_VD1_CTL, HVLD);
	}
}

#endif	// end of PE_VD1
