/******************************************************************
 * vd1.h
 * 
 * VD1 driver
 * 
 * Copyright(C) SEIKO EPSON CORPORATION 2009. All rights Reserved.
 *****************************************************************/

#ifndef VD1_H_
#define VD1_H_


#include <s1c176xx.h>


#ifdef	BIT_FIELD
/***********************************************
 ****** The Definition of bit field         ****
 ***********************************************/
struct vd1_ctlBitF {
	unsigned int	vd1md	: 1;
	unsigned int			: 4;
	unsigned int	hvld	: 1;
	unsigned int			: 2;
};
#endif	// end of BIT_FIELD


/***********************************************
 ****** The Definition of base address      ****
 ***********************************************/
#define	VD1_BASE_ADDR						(BASE_ADDR+VD1_OFFSET)


/***********************************************
 ****** The Definition of Power Generator ******
 ****** [VD1]                         **********
 ***********************************************/
// VD1 Control Register
#define	R08_VD1_CTL							(volatile unsigned char *)(unsigned long)(VD1_BASE_ADDR+0x00)
	#define	HVLD_SFT							5
	#define	VD1MD_SFT							0
	#define	HVLD								BIT(0x01, HVLD_SFT)			// VD1 Heavy Load Protection Mode
		#define	VD1_OFF								0x00						// off
		#define	VD1_ON								0x01						// on
	#define	VD1MD								BIT(0x01, VD1MD_SFT)		// Flash Erase/Program Mode
		#define	VD1_NORMAL							0x00						// normal 1.8v
		#define	VD1_FLASH							0x01						// flash  2.5v

#ifdef	BIT_FIELD
#define VD1_CTL								*(volatile unsigned char *)(BASE_ADDR+0x1120)
#define BF_VD1_CTL							(*(volatile struct vd1_ctlBitF *)(BASE_ADDR+0x1120))
	#define VD1_CTL_HVLD						BF_VD1_CTL.hvld				// VD1 heavy load protection mode
	#define VD1_CTL_VD1MD						BF_VD1_CTL.vd1md			// Flash erase/program mode
#endif	// end of BIT_FIELD


#endif	// end of VD1_H_
